// テキストの色を保持する変数です。
// iPhoneは黒(#000)、androidの場合は白(#fff)にしています。
var textColor = "#000";
if(Titanium.Platform.osname=="android") {
    textColor = "#fff";
}

// テーブルビュー(良くあるリストビュー)の部品を生成します。
// 初期状態では、loading...と表示しています
var table = Titanium.UI.createTableView({
	data: [{title: "loading..."}]
});

// このblog.jsを実行しているwindowを取得しwindow変数に代入しています。
var window = Titanium.UI.currentWindow;

// 現在のウインドーに先ほど生成したtableを追加します。
window.add(table);

// テーブルをクリックしたときの挙動を記述します。
table.addEventListener("click", function(event) {
  var new_window = Titanium.UI.createWindow({
    title: event.rowData.pageTitle,
    url: "web.js",
    link: event.rowData.link
  });
  Titanium.UI.currentTab.open(new_window, {animated : true});
});

// tableのRSSを読み込むコードです。
function load_feed() {
  Titanium.API.info("Opening "+window.feed_url);
  Titanium.Yahoo.yql("SELECT * FROM feed WHERE url='"+window.feed_url+"'",
    function(e) { // yqlの実行結果がe.dataに返ります。
      table.setData(e.data.item.map(function(item) {
        var row = Titanium.UI.createTableViewRow({
          height: "auto", // 高さは自動に調節。
          hasDetail: true // iOSではリストに丸いアイコンが付きます。
        });
        // 「枠」内に表示する文字を入れるLabelを生成します。
        var message = Titanium.UI.createLabel({
          text: item.title, // 表示内容はitem.title
          color: textColor, // 文字色は、頭で指定した色
          font: { fontSize: 13 }, // フォントのサイズ
          height: "auto", // 高さは内容に合わせて自動
          top: 8, bottom: 8, // 上下左右から8px開ける
          left: 8, right: 8
        });
        row.add(message);
        row.pageTitle = item.title;
        row.link = item.link;
        return(row);
      }));
    }
  );
}
load_feed();

// リロード処理を記述。iPhoneとAndroidで挙動が異なります。本誌では掲載していません。
if(Titanium.Platform.osname=="iphone") {
  // iPhoneではリロードボタンをタイトルバーの右に付けます。
  // リロードボタンのアイコンはOSから提供されている物を使います。
  var button = Titanium.UI.createButton({
    systemButton:Titanium.UI.iPhone.SystemButton.REFRESH
  });
// このボタンがクリックされると、load_feedが呼び出されてリロード処理が行われます。
  button.addEventListener('click',load_feed);
  // ボタンをウインドーのナビゲーションバーの右に追加します。
  window.setRightNavButton(button);
}

else if(Titanium.Platform.osname=="android") {
  // Androidの場合、メニューキーを押した場合の処理を記述します。
  var activity = Ti.Android.currentActivity;
  // activityからメニューを生成するというコールバックが呼ばれたときに、メニューを生成します。
  activity.onCreateOptionsMenu = function(e) { // この処理は初めてmenuキーを押したとき一度だけ呼び出されます。
    var r = e.menu.add({title : 'Reload'}); // リロードというメニューを生成します。
    r.addEventListener('click', load_feed); // メニューがクリックされると、load_feedが呼び出され、リロード処理が行われます
  };
}